/* ================================================================================== */
/* Copyright (c) 1998-1999 3Com Corporation or its subsidiaries. All rights reserved. */
/* ================================================================================== */

#pragma once


#if PRAGMA_ALIGN_SUPPORTED
#pragma options align=mac68k
#endif


#include <Pilot.h>
#include "Rom Transfer.rsrc.h"
#include <SerialMgr.h>
#include <Crc.h>


// Globals.

extern UInt16 gPortReference;


#define kPort_Pilot				0
#define kTicksPerSecond			100

#define kBaud_1200				1200
#define kBaud_2400				2400
#define kBaud_4800				4800
#define kBaud_9600				9600
#define kBaud_14400				14400
#define kBaud_19200				19200
#define kBaud_28800				28800
#define kBaud_38400				38400
#define kBaud_57600				57600
#define kBaud_57600				57600
#define kBaud_115200			115200

// Error Constants.

#define kError_CommOpen			10000
#define kError_CommNotOpen		10001
#define kError_InvalidPort		10002
#define kError_CantOpenPort		10003
#define kError_PortOpen			10004

// Prototypes.

#ifdef __cplusplus
extern "C" {
#endif


Int16		Comm_Initialize	(Int16 iPort, DWord iBaud);
void		Comm_Dispose	(void);
void		Comm_ClearError	(void);


#ifdef __cplusplus
}
#endif


#if PRAGMA_ALIGN_SUPPORTED
#pragma options align=reset
#endif
