/* ================================================================================== */
/* Copyright (c) 1998-1999 3Com Corporation or its subsidiaries. All rights reserved. */
/* ================================================================================== */

#ifndef _PALM_H_
#define _PALM_H_

#include "PalmPack.h"

#define ControlPtr	Palm_ControlPtr
#define ListPtr		Palm_ListPtr

// Defined in both CharAttr.h and ...\VC\Includes\xlocinfo.h
#undef _XA
#undef _XS
#undef _BB
#undef _CN
#undef _DI
#undef _LO
#undef _PU
#undef _SP
#undef _UP
#undef _XD

// From Pilot.h

	// From SysAll.h

		#include <Common.h>
		#include <SysTraps.h>
		#include <SystemMgr.h>
		//#include <DebugMgr.h>
		#include <ErrorMgr.h>
		//#include <StringMgr.h>
		//#include <SysUtils.h>
		#include <MemoryMgr.h>
		#include <DataMgr.h>
		#include <FeatureMgr.h>

		#include <Preferences.h>
		//#include <Localize.h>
		//#include <TimeMgr.h>
		//#include <AlarmMgr.h>
		//#include <SoundMgr.h>
		//#include <Keyboard.h>
		//#include <GraffitiReference.h>
		//#include <AppLaunchCmd.h>


	// From UIAll.h

		#include <UICommon.h>
		//#include <Init.h>
		#include <Rect.h>
		#include <Font.h>
		//#include <FontSelect.h>
		#include <Window.h>
		#include <Chars.h>
		//#include <InsPoint.h>
		//#include <GraffitiShift.h>
		#include <Event.h>
		//#include <ClipBoard.h>
		#include <Control.h>
		#include <Field.h>
		#include <List.h>
		#include <ScrollBar.h>
		#include <Table.h>
		#include <Form.h>
		//#include <Menu.h>
		//#include <Category.h>
		//#include <Find.h>
		//#include <SelDay.h>
		//#include <SelTime.h>
		//#include <AboutBox.h>
		//#include <PhoneLookup.h>

	#define	NON_PORTABLE
	#include <Globals.h>
	//#include <UIGlobals.h>
	#undef NON_PORTABLE


// Additional bits we need

#include "KeyMgr.h"			// keyBitHard1
#include "NetMgr.h"
#include "PenMgr.h"			// PenScreenToRaw
#include "SysEvtMgr.h"		// EvtEnqueuePenPoint, EvtEnqueueKey
#include "SystemPkt.h"		// SysPktBodyType, etc.
							// (Be sure to include _before_ DebugPrv.h so that
							//  _sysPktBodyCommon is defined.)
#include "SerialLinkMgr.h"	// SlkPktHeaderType, slkSocketDebugger, etc.
#include "FatalAlert.h"		// fatalReset, etc.

#include "HTALAPI.h"		// htalLibTrapLast
#include "INetMgr.h"		// inetLibName, inetLibTrapLast
#include "IrLib.h"			// irLibName, irLibTrapLast
#include "SecurityMgr.h"	// secLibName, secLibTrapSetKeyPath
#include "WebLib.h"			// webLibName, webLibTrapLast
#include "NetPlugIn.h"		// npiLibTrapLast


#undef small	// Defined in a VC++ header (RPCNDR.H).
#include "DLCommon.h"
#include "DLServer.h"

#include "TextMgr.h"			// TxtGetNextChar
#include "IntlMgr.h"			// intlSelector

#define NON_PORTABLE
#include "DebugPrv.h"			// BreakpointType
#include "KeyPrv.h"				// KeyHandleInterrupt
#include "DataPrv.h"			// DatabaseHdrPtr, etc.
#include "SysEvtPrv.h"			// SysEvtMgrGlobalsPtr
#include "SystemPrv.h"
#include "Hardware.h"			// hwrDisplayWidth, hwrSystemTop, hwrSystemHeight
#include "MemoryPrvNew.h"		// MemNVParams

#include "M68328Hwr.h"			// HwrDBallType

	// Bank_MC68328.cpp needs M68328Hwr.h, while Bank_MC68EZ328.cpp needs
	// M68EZ328Hwr.h.  These two header files define conflicting defintions
	// of HwrDBallType and HwrDBallPtr.  To avoid that collision, use some
	// pre-processor majik.
#define HwrDBallType HwrDBallEZType
#define HwrDBallPtr HwrDBallEZPtr
#include "M68EZ328Hwr.h"		// HwrDBallType
#undef HwrDBallType
#undef HwrDBallPtr

#include "M68681Hwr.h"			// HwrDuartType

	// Controls:
	//	HardwarePrv.h
	//		hwr68328Base
	//		hwrCardBase0
	//		hwrCardSize
	//		hwrFlashBase
	//		hwrFlashSize
	//		hwrCardOffsetMask
	//		hwrROMWidth
	//		hwrDuartBase
	//		hwrDuartClock
	//		hwrDuartACRReg
	//	SystemPrv.h
	//		sysDefaultSerPort
#undef HW_TARGET
#define HW_TARGET HW_TARGET_TD1

	// Controls: nothing (for us), but it needs to be defined anyway
#define HW_REV 1

#include "HardwarePrv.h"		// hwr68328Base, hwrDuartBase
#include "HardwareTD1.h"		// hwrTD1PortFLCDEnableOn, hwrTD1PortFPanelMask, etc.

	// Undef these, as they'll get redefined in HardwareEZ.h
#undef hwrWriteProtectOff
#undef hwrWriteProtectOn

#include "HardwareEZ.h"

	// Undef these again so that we don't accidentally try using them.
#undef hwrWriteProtectOff
#undef hwrWriteProtectOn


#undef NON_PORTABLE


#if defined(_WINDOWS) || defined(UNIX)		// Needed for Gremlins
struct Point
{
	short	v;
	short	h;
};
typedef Point*	PointPtr;
#endif



#include "PalmPackPop.h"

#undef ControlPtr
#undef ListPtr

// Defined in both CharAttr.h and ...\VC\Includes\xlocinfo.h
#undef _XA
#undef _XS
#undef _BB
#undef _CN
#undef _DI
#undef _LO
#undef _PU
#undef _SP
#undef _UP
#undef _XD

// UICommon.h defines these, but they conflict with the STL functions

#undef min
#undef max


#endif /* _PALM_H_ */

