#define MAC_CONTEXT
#define MP_EXT
#define MP_INIT(x) = x

#include "EXTERN.h"
#include "perl.h"

int link()
{
	if (dowarn)
		warn("MacPerl: link always fails");
		
	return -1;
}

unsigned short umask(unsigned short arg)
{
	if (dowarn && arg)
		warn("MacPerl: nonzero argument to umask() ignored");
	
	return 0;
}
/* Calls that don't exist on the mac */

/* Borrowed from msdos.c
 * Just pretend that everyone is a superuser
 */
/* DISPATCH_START */
#define ROOT_UID	0
#define ROOT_GID	0
Uid_t
(getuid)(void)
{
	return ROOT_UID;
}

Uid_t
(geteuid)(void)
{
	return ROOT_UID;
}

Gid_t
(getgid)(void)
{
	return ROOT_GID;
}

Gid_t
(getegid)(void)
{
	return ROOT_GID;
}

int
(setuid)(int uid)
{ 
	return (uid==ROOT_UID?0:-1);
}

int
setgid(int gid)
{ 
	return (gid==ROOT_GID?0:-1); 
}

#undef execv

(execv)()
{
	croak("execv() not implemented on the Macintosh");
}

#undef execvp

(execvp)()
{
	croak("execvp() not implemented on the Macintosh");
}

kill()
{
	croak("kill() not implemented on the Macintosh");
}
/* DISPATCH_END */

pid_t (getpid)()
{
	return 1;
}

static char *
setup_argstr(SV *really, SV **mark, SV **sp)
{
  char *junk, *tmps = Nullch;
  register size_t cmdlen = 0;
  size_t rlen;
  register SV **idx;

  idx = mark;
  if (really) {
    tmps = SvPV(really,rlen);
    if (*tmps) {
      cmdlen += rlen + 1;
      idx++;
    }
  }
  
  for (idx++; idx <= sp; idx++) {
    if (*idx) {
      junk = SvPVx(*idx,rlen);
      cmdlen += rlen ? rlen + 1 : 0;
    }
  }
  New(401,PL_Cmd,cmdlen,char); /* kaar - changed to PL_Cmd */

  if (tmps && *tmps) {
    strcpy(PL_Cmd,tmps); /* kaar - changed to PL_Cmd */
    mark++;
  }
  else *PL_Cmd = '\0'; /* kaar - changed to PL_Cmd */
  while (++mark <= sp) {
    if (*mark) {
      strcat(PL_Cmd," "); /* kaar - changed to PL_Cmd */
      strcat(PL_Cmd,SvPVx(*mark,na)); /* kaar - changed to PL_Cmd */
    }
  }
  return PL_Cmd; /* kaar - changed to PL_Cmd */
}  /* end of setup_argstr() */

int do_spawn(char * command)
{
#if 0
    FILE * temp = my_popen(command, "r"); /* kaar - changed to return FILE* */
    char *   data;
    
    while (data = sfreserve(temp, -1, 0))
	write(1, data, sfslen());
	
    my_pclose(temp);
#endif

	return 0;
}

int do_aspawn(SV *really,SV **mark,SV **sp)
{
  if (sp > mark) {
    return do_spawn(setup_argstr(really,mark,sp));
  }

  return -1;
}  /* end of do_aspawn() */

char * sys_errlist[] = {
	"No error",
	"Operation not permitted",
	"No such file or directory",
	"No such process",
	"Interrupted system call",
	"Input/output error",
	"Device not configured",
	"Argument list too long",
	"Exec format error",
	"Bad file descriptor",
	"No child processes",
	"Operation would block",
	"Cannot allocate memory",
	"Permission denied",
	"Bad address",
	"Block device required",
	"Device busy",
	"File exists",
	"Cross-device link",
	"Operation not supported by device",
	"Not a directory",
	"Is a directory",
	"Invalid argument",
	"Too many open files in system",
	"Too many open files",
	"Inappropriate ioctl for device",
	"Text file busy",
	"File too large",
	"No space left on device",
	"Illegal seek",
	"Read-only file system",
	"Too many links",
	"Broken pipe",
	"Numerical argument out of domain",
	"Result too large",
	"(unknown)",
	"Operation now in progress",
	"Operation already in progress",
	"Socket operation on non-socket",
	"Destination address required",
	"Message too long",
	"Protocol wrong type for socket",
	"Protocol not available",
	"Protocol not supported",
	"Socket type not supported",
	"Operation not supported on socket",
	"Protocol family not supported",
	"Address family not supported by protocol family",
	"Address already in use",
	"Can't assign requested address",
	"Network is down",
	"Network is unreachable",
	"Network dropped connection on reset",
	"Software caused connection abort",
	"Connection reset by peer",
	"No buffer space available",
	"Socket is already connected",
	"Socket is not connected",
	"Can't send after socket shutdown",
	"Too many references: can't splice",
	"Connection timed out",
	"Connection refused",
	"Too many levels of symbolic links",
	"File name too long",
	"Host is down",
	"No route to host",
	"Directory not empty",
	"Too many processes",
	"Too many users",
	"Disc quota exceeded",
	"Stale NFS file handle",
	"Too many levels of remote in path",
	"RPC struct is bad",
	"RPC version wrong",
	"RPC prog. not avail",
	"Program version wrong",
	"Bad procedure for program",
	"No locks available",
	"Function not implemented",
	"Inappropriate file type or format",
	0
};

void
prime_env_iter(void)
/* Fill the %ENV associative array with all logical names we can
 * find, in preparation for iterating over it.
 */
{
  HV *envhv;
  char **env;
  STRLEN len;

  if (!gMustPrime || !PL_envgv) return; /* kaar - changed to PL_envgv */
  envhv = GvHVn(PL_envgv); /* kaar - changed to PL_envgv */
  gMustPrime = false;
  /* Perform a dummy fetch as an lval to insure that the hash table is
   * set up.  Otherwise, the hv_store() will turn into a nullop */
  (void) hv_fetch(envhv,"DEFAULT",7,TRUE);
  (void) hv_delete(envhv,"DEFAULT",7, G_DISCARD);
  for (env = environ; *env; ++env) {
    len = strchr(*env, '=') - *env;
    hv_store(envhv,*env,len,newSVpv(*env+len+1, 0),0);
  }
}  /* end of prime_env_iter */

FILE * my_popen(char * command, char * mode)
{
#if 0
	PipeDescrPtr	pipe;
	
	if (!gHasEmulators) {
		gHasEmulators = true;
		AddWriteEmulationProc("pwd", EmulatePwd);
		AddWriteEmulationProc("directory", EmulatePwd);
		AddWriteEmulationProc("Directory", EmulatePwd);
		AddWriteEmulationProc("hostname", EmulateHostname);
		AddWriteEmulationProc("glob", EmulateGlob);
	}
	
	if (!strcmp(command, "-"))
		croak("Implicit fork() on a Mac? No forking chance");
	
	New(666, pipe, 1, PipeDescr);
	
	if (!pipe)
		return NULL;
		
	if (FSpMakeTempFile(&pipe->pipeFile))
		goto failed;
	pipe->execute	=	nil;
	
	switch(*mode)	{
	case 'r':
		{
			/* Ugh ! A hardcoded command  ! */
			EmulationProc proc = FindWriteEmulationProc(command, &command);
			
			if (proc) {
				if (!(pipe->tempFile	= fopen(FSp2FullPath(&pipe->pipeFile), "w")))
					goto delete;
				if (proc(pipe->tempFile, command))
					goto delete;
				fclose(pipe->tempFile);
			} else if (SubLaunch(command, nil, &pipe->pipeFile, &pipe->pipeFile, &pipe->status))
				goto delete;
			
			if (!(pipe->tempFile	= fopen(FSp2FullPath(&pipe->pipeFile), "r")))
				goto delete;
			break;
		}
	case 'w':
		New(667, pipe->execute, strlen(command)+1, char);
		if (!pipe->execute || !(pipe->tempFile	= fopen(FSp2FullPath(&pipe->pipeFile), "w")))
			goto delete;
		strcpy(pipe->execute, command);
		break;
	}
	
	pipe->next	=	pipes;
	pipes			=	pipe;
	
	if (!sweeper)	{
		atexit(sweep);
		sweeper	=	true;
	}

	return pipe->tempFile;
delete:
	if (pipe->execute)
		Safefree(pipe->execute);
	HDelete(pipe->pipeFile.vRefNum, pipe->pipeFile.parID, pipe->pipeFile.name);
failed:
	Safefree(pipe);
#endif
	return NULL;
}

I32 my_pclose(FILE * f)
{
#if 0
	OSErr				err;
	PipeDescrPtr *	prev;
	PipeDescrPtr	pipe;
	
	for (prev = (PipeDescrPtr *) &pipes; pipe = *prev; prev = &pipe->next)
		if (pipe->tempFile == f)
			break;
	
	if (!pipe)
		return -1;
	
	*prev = pipe->next;
	
	fclose(f);
	
	if (pipe->execute)
		err = SubLaunch(pipe->execute, &pipe->pipeFile, nil, nil, &pipe->status);
	else
		err = noErr;
		
	HDelete(pipe->pipeFile.vRefNum, pipe->pipeFile.parID, pipe->pipeFile.name);
	if (pipe->execute)
		Safefree(pipe->execute);
	Safefree(pipe);
	
	return err? -1 : (int) pipe->status;
#endif
	return 0;
}


bool
do_exec(char *cmd)
{
    return false;
}


char* _environ[] = {NULL};
char** environ = _environ;

