/* ================================================================================== */
/* Copyright (c) 1998-1999 3Com Corporation or its subsidiaries. All rights reserved. */
/* ================================================================================== */

#pragma once

#include "ErrorHandling.h"		// ErrCode
#include "Platform_Files.h"		// FileReference


typedef struct regstruct CPU_regs;

ErrCode	CPU_init				(int deviceType,
								 FileReference& ramFileRef,
								 FileReference& romFileRef,
								 uae_s32 ramSize);
void	CPU_dispose				(void);
void	CPU_reset				(void);
void	CPU_run					(void);
Bool	CPU_stop				(void);
Bool	CPU_wait				(DWORD timeout);
Bool	CPU_executeuntilatrap	(void);
void	CPU_pen					(Bool down, int x, int y);
void	CPU_button				(Bool down, int button);
void	CPU_hotsync				(Bool down);
void	CPU_putkey				(BYTE key);
void	CPU_setsounds			(Bool enablesounds);


class CPUStopper
{
	public:
				CPUStopper (HWND, const char*);
				~CPUStopper ();

		Bool	Stopped () { return ok; }

	private:
		Bool	ok;
};

